<?php
if (session_status() == PHP_SESSION_NONE) {
    session_start();
}
if( !isset($_SESSION["authID"]) ){
    header("Location: ../login");
    exit();
}


require_once dirname(dirname(__FILE__)) . '/classes/posItems.php';
require_once dirname(dirname(__FILE__)) . '/classes/posUploads.php';
require_once dirname(dirname(__FILE__),2) . '/variables/menu.php';
require_once dirname(dirname(__FILE__),2) . '/variables/settings.php';
require_once dirname(dirname(__FILE__),2) . '/variables/variables.php';
require_once dirname(dirname(__FILE__),2) . '/classes/dbServices.php';
require_once dirname(dirname(__FILE__),2) . '/LobbyPOS/classes/currency.php';


$dbs = new dbServices();
$show = new shows();
$items = new posItems();
$currency = new currency();
$uploads = new uploads();

?>
<!DOCTYPE html>
<html lang="en">
<head>
    <link rel="stylesheet" type="text/css" href="../../styles/main.css">
    <link rel="stylesheet" type="text/css" href="../../styles/manager.css">
    <link rel="stylesheet" type="text/css" href="../css/posMain.css">

    <script src="../../js/showsAdmin.js"></script>
    <script src="../js/posJs.js"></script>
    <?php include("../../sections/headerAdmin.php"); ?>
</head>
<body>
<div class = "menuContainer">
    <?php include("../../sections/menu.php") ?>
</div>

<div id="mainSection">
    <div class="boxesSABluetext" id="searchPeople">
        <p class="boxHeader">POS Administration: Create Item</p>
        <div id="searchPeopleForm" class="boxes">
            <?php
            if(isset($_POST['itemAdmin'])){
                $items->allItemDataByID($_POST['itemAdmin']);

            echo '<form method="post" name="createItem" id="createUserForm" action="../sections/adminPost.php" target="status" enctype="multipart/form-data">';
                echo '<fieldset id="fset1">';
                    echo '<label>Name </label>';
                    echo '<input class="fields" id="userSearch" type="text" name="name_edit" value="'.$items->getPosItemsName().'" required/>';
                    echo '<br><br>';
                    echo '<label>Description </label>';
                    echo '<textarea class="fields" id="realSearch" name="desc_edit" required>'.$items->getPosItemsDescription().'</textarea>';
                    echo '<br><br>';
                    echo '<label>Price </label>';
                    echo '<input class="fields" id="itemPrice" type="text" name="itemPrice" value="'.$currency->displayCurrency($items->getPosItemsPrice()).'"/>';
                    echo '<br><br>';
                    echo '<label>Cost </label>';
                    echo '<input class="fields" id="itemPrice" type="text" name="itemCost" value="'.$currency->displayCurrency($items->getPosItemsItemCost()).'"/>';
                    echo '<br><br>';
                    echo '<label>On Hand </label>';
                    echo '<input class="fields" id="itemPrice" type="text" name="itemOnHand" value="'.$items->getPosItemsItemsOnHand().'"/>';
                    echo '<br><br>';
                    echo '<label>Position </label>';
                    echo '<input class="fields" id="itemPrice" type="text" name="itemPosition"value="'.$items->getPosItemsPosition().'"/>';
                    echo '<br><br>';
                    echo '<label>Status ';
                    echo '<select name="itemStatus" required>';
                    echo '<option value="" selected>Choose</option>';
                    if($items->getPosItemsStatus()){
                        echo '<option value="1" selected>Active</option>';
                        echo '<option value="0">Inactive</option>';
                    }else{
                        echo '<option value="1">Active</option>';
                        echo '<option value="0" selected>Inactive</option>';
                    }
                    echo '</select>';
                    echo '</label>';
                    echo '<br><br>';
                    echo '<label> Item Image ';
                    $uploads->createFileUpload('itemImage');
                    echo '<img src="../images/'.$items->getPosItemsImage().'" width="100px" height="100px">';
                    echo '<input type="hidden" name="prevImage" value="'.$items->getPosItemsImage().'">';
                    echo'</label>';
                    echo '<br><br>';
                    echo'<label> Use Name ';
                    echo '<select name="itemUseName" required>';
                    echo '<option value="" selected>Choose</option>';
                    if($items->getPosItemsUseName()){
                        echo '<option value="1" selected>Yes</option>';
                        echo '<option value="0">No</option>';
                    }else{
                        echo '<option value="1">Yes</option>';
                        echo '<option value="0" selected>No</option>';
                    }
                    echo '</select>';
                    echo'</label>';
                    echo'<label> Use Image ';
                    echo '<select name="itemUseImage" required>';
                    echo '<option value="" selected>Choose</option>';
                    if($items->getPosItemsUseImage()){
                        echo '<option value="1" selected>Yes</option>';
                        echo '<option value="0">No</option>';
                    }else{
                        echo '<option value="1">Yes</option>';
                        echo '<option value="0" selected>No</option>';
                    }
                    echo '</select>';
                    echo'</label>';
                    echo'<label> Use Description ';
                    echo '<select name="itemUseDesc" required>';
                    echo '<option value="" selected>Choose</option>';
                    if($items->getPosItemsUseDescription()){
                        echo '<option value="1" selected>Yes</option>';
                        echo '<option value="0">No</option>';
                    }else{
                        echo '<option value="1">Yes</option>';
                        echo '<option value="0" selected>No</option>';
                    }
                    echo '</select>';
                    echo'</label>';
                    echo '<br><br>';
                    echo '</fieldset>';
                    echo '<input type="hidden"  name="itemIDEdit" value="'.$items->getPosItemsID().'">';
                    echo '<input type="reset" id="clear" class="button" value="Clear">';
                    echo '<input type="submit" id="button" class="button" name="editItemButton" value="Save">';
            echo '</form>';
            }
            else{

                echo '<form method="post" name="createItem" id="createUserForm" action="../sections/adminPost.php" target="status" enctype="multipart/form-data">';
                echo '<fieldset id="fset1">';
                echo '<label>Name </label>';
                echo '<input class="fields" id="userSearch" type="text" name="name_edit" required/>';
                echo '<br><br>';
                echo '<label>Description </label>';
                echo '<textarea class="fields" id="realSearch" name="desc_edit" required></textarea>';
                echo '<br><br>';
                echo '<label>Price </label>';
                echo '<input class="fields" id="itemPrice" type="text" name="itemPrice"/>';
                echo '<br><br>';
                echo '<label>Cost </label>';
                echo '<input class="fields" id="itemPrice" type="text" name="itemCost"/>';
                echo '<br><br>';
                echo '<label>On Hand </label>';
                echo '<input class="fields" id="itemPrice" type="text" name="itemOnHand"/>';
                echo '<br><br>';
                echo '<label>Position </label>';
                echo '<input class="fields" id="itemPosition" type="text" name="itemPosition"/>';
                echo '<br><br>';
                echo '<label>Status ';
                echo '<select name="itemStatus" required>';
                echo '<option value="" selected>Choose</option>';
                echo '<option value="1" selected>Active</option>';
                echo '<option value="0">Inactive</option>';
                echo '</select>';
                echo '</label>';
                echo '<br><br>';
                echo '<label> Item Image ';
                $uploads->createFileUpload('itemImage');
                echo'</label>';
                echo '<br><br>';
                echo'<label> Use Name ';
                echo '<select name="itemUseName" required>';
                echo '<option value="" selected>Choose</option>';
                echo '<option value="1" selected>Yes</option>';
                echo '<option value="0">No</option>';
                echo '</select>';
                echo'</label>';
                echo'<label> Use Image ';
                echo '<select name="itemUseImage" required>';
                echo '<option value="" selected>Choose</option>';
                echo '<option value="1" selected>Yes</option>';
                echo '<option value="0">No</option>';
                echo '</select>';
                echo'</label>';
                echo'<label> Use Description ';
                echo '<select name="itemUseDesc" required>';
                echo '<option value="" selected>Choose</option>';
                echo '<option value="1" selected>Yes</option>';
                echo '<option value="0">No</option>';
                echo '</select>';
                echo'</label>';
                echo '<br><br>';
                echo '</fieldset>';
                echo '<input type="reset" id="clear" class="button" value="Clear">';
                echo '<input type="submit" id="button" class="button" name="editItemButton" value="Save">';
                echo '</form>';
            }

            ?>
<!--            <form method="post" id="sendSearchForm" action="../../sections/peopleSearch.php" target="peopleResults">-->
<!--                <input type="hidden" name="field" id="fieldName" value="">-->
<!--                <input type="hidden" name="data" id="searchData" value="">-->
<!--            </form>-->

<!--            <iframe class="iframe" name="status" id="formStatus" src="../../sections/popupStatus.php"> People Status</iframe>-->

        </div>


<!--        <div id="searchPeopleResults" class="" style="max-width: fit-content">-->
<!--            <iframe class="iframeS" id="peopleSearchResults" name="peopleResults" src="../../sections/peopleSearch.php"></iframe>-->
<!--        </div>-->

    </div>
    <div class="boxesSABluetext" id="searchPeople">
        <p class="boxHeader">POS Administration: Edit Item</p>
        <div id="editShowsArea" class="boxes">

            <table>
                <tr><th>Item</th></tr>
                <tr><td><form method="post" action="#" >
                            <select name="itemAdmin" onchange="this.form.submit();return false">
                                <?php $items->itemFormList(); ?>
                            </select>
                        </form></td></tr>

            </table>

        </div>

    <iframe class="iframePerforamnce" name="status" id="status" src="../sections/adminPost.php"></iframe>
    </div>

</div>

</body>
</html>