<?php

require_once dirname(dirname(__FILE__),2). '/classes/item.php';
require_once dirname(dirname(__FILE__),2). '/classes/person.php';
require_once dirname(dirname(__FILE__),2) . '/stripe/stripe/init.php';
require_once dirname(dirname(__FILE__),2). '/classes/dateTimeService.php';
require_once dirname(dirname(__FILE__),2). '/LobbyPOS/classes/posDbServices.php';
require_once dirname(dirname(__FILE__),2) . '/stripe/payClasses/cardServicesOpen.php';

use lobbypos\posDbServices as PosDbServiceL;

class pos
{
    private $sandbox;
    private $api_version;
    private $api_endpoint;
    private $api_key;
    private $posPurchasesId;
    private $posPurchasesDescription;
    private $posPurchasesPrice;
    private $posPurchasesCardType;
    private $posPurchasesLast4;
    private $posPurchasesTimeStamp;
    private $posPurchasesUserId;
    private $posPurchasesPosId;
    private $posPurchasesPosName;
    private $posPurchasesTID;
    private $posPurchasesFileName;
    private $endpoint_secret;
    private $posPurchaseTip;

    private $posStatusID;
    private $posStatusPi;
    private $posStatusCode;
    private $posStatusMessage;
    private $posStatusTimeStamp;
    private $posStatusUserID;
    private $posStatusPosID;

    private $paymentStatus;

    public function getSandbox(): bool
    {
        return $this->sandbox;
    }

    public function setSandbox(bool $sandbox): void
    {
        $this->sandbox = $sandbox;
    }

    public function getApiVersion(): string
    {
        return $this->api_version;
    }

    public function setApiVersion(string $api_version): void
    {
        $this->api_version = $api_version;
    }

    public function getApiEndpoint(): string
    {
        return $this->api_endpoint;
    }

    public function setApiEndpoint(string $api_endpoint): void
    {
        $this->api_endpoint = $api_endpoint;
    }

    public function getApiKey(): string
    {
        return $this->api_key;
    }

    public function setApiKey(string $api_key): void
    {
        $this->api_key = $api_key;
    }

    public function getPosPurchasesId()
    {
        return $this->posPurchasesId;
    }

    public function setPosPurchasesId($posPurchasesId): void
    {
        $this->posPurchasesId = $posPurchasesId;
    }

    public function getPosPurchasesDescription()
    {
        return $this->posPurchasesDescription;
    }

    public function setPosPurchasesDescription($posPurchasesDescription): void
    {
        $this->posPurchasesDescription = $posPurchasesDescription;
    }

    public function getPosPurchasesPrice()
    {
        return $this->posPurchasesPrice;
    }

    public function setPosPurchasesPrice($posPurchasesPrice): void
    {
        $this->posPurchasesPrice = $posPurchasesPrice;
    }

    public function getPosPurchasesTimeStamp()
    {
        return $this->posPurchasesTimeStamp;
    }

    public function setPosPurchasesTimeStamp($posPurchasesTimeStamp): void
    {
        $this->posPurchasesTimeStamp = $posPurchasesTimeStamp;
    }

    public function getPosPurchasesUserId()
    {
        return $this->posPurchasesUserId;
    }

    public function setPosPurchasesUserId($posPurchasesUserId): void
    {
        $this->posPurchasesUserId = $posPurchasesUserId;
    }

    public function getPosPurchasesPosId()
    {
        return $this->posPurchasesPosId;
    }

    public function setPosPurchasesPosId($posPurchasesPosId): void
    {
        $this->posPurchasesPosId = $posPurchasesPosId;
    }

    public function getPosPurchasesPosName()
    {
        return $this->posPurchasesPosName;
    }

    public function setPosPurchasesPosName($posPurchasesPosName): void
    {
        $this->posPurchasesPosName = $posPurchasesPosName;
    }

    public function getPosPurchasesTID()
    {
        return $this->posPurchasesTID;
    }

    public function setPosPurchasesTID($posPurchasesTID): void
    {
        $this->posPurchasesTID = $posPurchasesTID;
    }

    public function getEndpointSecret()
    {
        return $this->endpoint_secret;
    }

    public function setEndpointSecret($endpoint_secret): void
    {
        $this->endpoint_secret = $endpoint_secret;
    }

    public function getPosStatusID()
    {
        return $this->posStatusID;
    }

    public function setPosStatusID($posStatusID): void
    {
        $this->posStatusID = $posStatusID;
    }

    public function getPosStatusPi()
    {
        return $this->posStatusPi;
    }

    public function setPosStatusPi($posStatusPi): void
    {
        $this->posStatusPi = $posStatusPi;
    }

    public function getPosStatusCode()
    {
        return $this->posStatusCode;
    }

    public function setPosStatusCode($posStatusCode): void
    {
        $this->posStatusCode = $posStatusCode;
    }

    public function getPosStatusMessage()
    {
        return $this->posStatusMessage;
    }

    public function setPosStatusMessage($posStatusMessage): void
    {
        $this->posStatusMessage = $posStatusMessage;
    }

    public function getPosStatusTimeStamp()
    {
        return $this->posStatusTimeStamp;
    }

    public function setPosStatusTimeStamp($posStatusTimeStamp): void
    {
        $this->posStatusTimeStamp = $posStatusTimeStamp;
    }

    public function getPosStatusUserID()
    {
        return $this->posStatusUserID;
    }

    public function setPosStatusUserID($posStatusUserID): void
    {
        $this->posStatusUserID = $posStatusUserID;
    }

    public function getPosStatusPosID()
    {
        return $this->posStatusPosID;
    }

    public function setPosStatusPosID($posStatusPosID): void
    {
        $this->posStatusPosID = $posStatusPosID;
    }

    public function getPosPurchasesCardType()
    {
        return $this->posPurchasesCardType;
    }

    public function setPosPurchasesCardType($posPurchasesCardType): void
    {
        $this->posPurchasesCardType = $posPurchasesCardType;
    }

    public function getPosPurchasesLast4()
    {
        return $this->posPurchasesLast4;
    }

    public function setPosPurchasesLast4($posPurchasesLast4): void
    {
        $this->posPurchasesLast4 = $posPurchasesLast4;
    }

    public function getPaymentStatus()
    {
        return $this->paymentStatus;
    }

    public function setPaymentStatus($paymentStatus): void
    {
        $this->paymentStatus = $paymentStatus;
    }

    public function getPosPurchasesFileName()
    {
        return $this->posPurchasesFileName;
    }

    public function setPosPurchasesFileName($posPurchasesFileName): void
    {
        $this->posPurchasesFileName = $posPurchasesFileName;
    }

    public function getPosPurchaseTip()
    {
        return $this->posPurchaseTip;
    }

    public function setPosPurchaseTip($posPurchaseTip): void
    {
        $this->posPurchaseTip = $posPurchaseTip;
    }





    public function __construct() {

        // Set sandbox (test mode) to true/false.
        $this->sandbox = false;

        $this->api_version = '2023-04-19 ';
        $this->api_endpoint = $this->sandbox ? 'https://api.stripe.com/v1/charges' : 'https://api.stripe.com/v1/charges';
        $this->api_key = $this->sandbox ? 'sk_test_51N74FoI3YumLaRA3ONisoZJr4Kz2ObCcTLSIOL0QGJ8vLbYapdlQdNBBBpxooB43UYaWEhc2ZDcodfgOquqfuF2000Qaoo43TZ' : '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';
        $this->endpoint_secret = $this->sandbox ? 'whsec_M8lHgetK2LfxzZusT1dpGXzrNOdT1HLw' : 'whsec_ZD2E60FPsPh8DEU3JJDgcqPJlamnRz1x';

    }

    function listPoss(){
        \Stripe\Stripe::setApiKey($this->getApiKey());

        //Fetch your readers
        $readers = \Stripe\Pos\Reader::all();

        //Print out the IDs of all readers (just for reference)
        echo '<label> Choose Pos ';
        echo '<select name="readerId" id="readerId">';
        foreach ($readers as $reader) {
            echo '<option value="'.$reader->id.'~~'.$reader->label.'" >'.$reader->label.'</option>';
        }
        echo '</select>';
        echo '</label><br><br>';

    }

    function listPossPOS(){
        \Stripe\Stripe::setApiKey($this->getApiKey());

        //Fetch your readers
        $readers =  \Stripe\Terminal\Reader::all();
        $terminalID = '';
        if(isset($_SESSION['terminalID'])){
            $terminalData = explode('~~', $_SESSION['terminalID']);
            $terminalID = $terminalData[0];
        }
        $reader =
        $posString = '';
        //Print out the IDs of all readers (just for reference)
        $posString .= '<select name="terminalID" class="terminalDrop" id="readerId" onchange="this.form.submit();return false">';
        $posString .= '<option value="">None</option>';
        foreach ($readers as $reader) {
        $selection = '';
            if($terminalID == $reader->id){
                $selection = 'selected';
            }
            $posString .= '<option value="'.$reader->id.'~~'.$reader->label.'" '.$selection.'>'.$reader->label.'</option>';
        }
        $posString .= '</select>';
        return $posString;

    }

    function storeCompletedTransaction(){

        $db = new PosDbServiceL();
        $conC = $db->dbConnect();
        $dt = new dateTimeService();

        if($conC != null){

            $tip = 0;
            if($this->posPurchaseTip != ''){
                $tip = $this->posPurchaseTip;
            }
            //echo '<script>alert(" fee '.$feeName.' desc '.$feeDescription.' Display '.$feeCode.' start '.$feeStartDate.' end '.$feeEndDate.' amount '.$feeAmount.' type '. $feeType.' status '.$feeStatusID.' created '.$feeCreatedBy.'")</script>';
            $createCust = $conC->prepare("INSERT INTO posPurchases VALUES (null,?,?,?,?,?,?,?,?,?,?,?)");
            if($createCust == false) {
                return ' Insert pos Purchase error ' . mysqli_error($conC);
            }
            $createCust->bind_param("sdsssissssi", $this->posPurchasesDescription,$this->posPurchasesPrice, $this->posPurchasesCardType, $this->posPurchasesLast4, $this->posPurchasesTimeStamp, $this->posPurchasesUserId, $this->posPurchasesPosId, $this->posPurchasesPosName, $this->posPurchasesTID, $this->posPurchasesFileName, $tip);
            if($createCust->execute() == false) {
                return ' Insert pos Purchase error ' . mysqli_error($conC);
            }
            $this->posPurchasesId = $createCust->insert_id;

        }
        $conC = null;
        $createCust->close();
        return $this->posPurchasesPosId;


    }

    function storeResults(){

        $db = new PosDbServiceL();
        $conC = $db->dbConnect();
        $dt = new dateTimeService();
        $timeStamp = $dt->createCurrentTimeStamp();

        if($conC != null){

            //echo '<script>alert(" fee '.$feeName.' desc '.$feeDescription.' Display '.$feeCode.' start '.$feeStartDate.' end '.$feeEndDate.' amount '.$feeAmount.' type '. $feeType.' status '.$feeStatusID.' created '.$feeCreatedBy.'")</script>';
            $createCust = $conC->prepare("INSERT INTO posStatus VALUES (null,?,?,?,?,?,?)");
            if($createCust == false) {
                return ' Insert pos Status error ' . mysqli_error($conC);
            }
            $createCust->bind_param("ssssis",  $this->posStatusPi, $this->posStatusCode, $this->posStatusMessage, $timeStamp, $this->posStatusUserID, $this->posStatusPosID);
            if($createCust->execute() == false) {
                return ' Insert pos Status error ' . mysqli_error($conC);
            }
            $this->posPurchasesId = $createCust->insert_id;

        }
        $conC = null;
        $createCust->close();
        return true;

    }

    function updateResults($payment_intent){

        $db = new PosDbServiceL();
        $conS = $db->dbConnect();

        if ($conS != null) {
            $resultC = $conS->prepare("UPDATE posStatus SET posStatusCode = ?, posStatusMessage = ? WHERE posStatusPi = ?");

            if ($resultC === FALSE) {
                return 'Update Pos Status error ' . mysqli_error($conS);
            }

            $resultC->bind_param("sss", $this->posStatusCode, $this->posStatusMessage, $payment_intent);
//            echo '<script>alert("'.$this->showStatus .' for '.$this->showDatesID.'")</script>';
            if ($resultC->execute() === FALSE) {
                return 'Update Pos Status error ' . mysqli_error($conS);
            }
            $resultC->close();

        }

        return true;
    }

    function updatePurchase($payment_intent){

        $db = new PosDbServiceL();
        $conS = $db->dbConnect();

        if ($conS != null) {

            $resultC = $conS->prepare("UPDATE posPurchases SET posPurchasesFileName = ? WHERE posPurchasesTID = ?");

            if ($resultC === FALSE) {
                return 'Update Pos Purchase error ' . mysqli_error($conS);
            }

            $resultC->bind_param("ss", $this->posPurchasesFileName,$payment_intent);
//            echo '<script>alert("'.$this->showStatus .' for '.$this->showDatesID.'")</script>';
            if ($resultC->execute() === FALSE) {
                return 'Update Pos Purchase error ' . mysqli_error($conS);
            }
            $resultC->close();

        }

        return true;
    }

    function findResults($payment_intent){

        $db = new PosDbServiceL();
        $conS = $db->dbConnect();

        if ($conS != null) {
            $resultS = $conS->query("SELECT posStatusCode, posStatusMessage FROM posStatus WHERE posStatusPi = '$payment_intent'");
            if($resultS){
                while ($n = $resultS->fetch_assoc()) {
                    $this->setPosStatusCode($n['posStatusCode']);
                    $this->setPosStatusMessage($n['posStatusMessage']);
                    return $this;
                }
                $resultS->close();
            }
        }

        $conS = null;
        return '';
    }


    function findAllPosPurchaseData($payment_intent){

        $db = new PosDbServiceL();
        $conS = $db->dbConnect();

        if ($conS != null) {
            $resultS = $conS->query("SELECT * FROM posPurchases WHERE posPurchasesTID = '$payment_intent'");
            if($resultS){
                while ($n = $resultS->fetch_assoc()) {
                    $this->setPosPurchasesId($n['posPurchasesDescriptionID']);
                    $this->setPosPurchasesDescription($n['posPurchasesDescription']);
                    $this->setPosPurchasesPrice($n['posPurchasesPrice']);
                    $this->setPosPurchasesCardType($n['posPurchasesCardType']);
                    $this->setPosPurchasesLast4($n['posPurchasesLast4']);
                    $this->setPosPurchasesTimeStamp($n['posPurchasesTimeStamp']);
                    $this->setPosPurchasesUserId($n['posPurchasesUserId']);
                    $this->setPosPurchasesPosId($n['posPurchasesTerminalId']);
                    $this->setPosPurchasesPosName($n['posPurchasesTerminalName']);
                    $this->setPosPurchasesTID($n['posPurchasesTID']);
                    $this->setPosPurchasesFileName($n['posPurchasesFileName']);
                    $this->setPosPurchaseTip($n['posPurchaseTip']);
                    return $this;
                }
                $resultS->close();
            }
        }

        $conS = null;
        return '';
    }

    function updateUid(){

        $db = new PosDbServiceL();
        $conS = $db->dbConnect();

        if ($conS != null) {
            $resultC = $conS->prepare("UPDATE posStatus SET posStatusUserID = ? WHERE posStatusPi = ?");

            if ($resultC === FALSE) {
                return 'Update Pos Uid Status error ' . mysqli_error($conS);
            }

            $resultC->bind_param("is", $this->posStatusUserID, $this->posStatusPi);
//            echo '<script>alert("'.$this->showStatus .' for '.$this->showDatesID.'")</script>';
            if ($resultC->execute() === FALSE) {
                return 'Update Pos Uid Status error ' . mysqli_error($conS);
            }
            $resultC->close();

        }

        return true;
    }

    function processPayment($paymentIntentId)
    {
        // Set your API key
        \Stripe\Stripe::setApiKey($this->api_key);

        try {
            $paymentIntent = \Stripe\PaymentIntent::retrieve($paymentIntentId);
            $paymentIntent->capture();
            return 'Payment successful';
        } catch (\Stripe\Exception\ApiErrorException $e) {
            // Handle API error
            http_response_code(400);
            return 'error capturing PaymentIntent: ' . $e->getMessage();
        }
    }

    function createPiFromPos($readerID, $card){
        $stripe = new \Stripe\StripeClient($this->getApiKey());
        \Stripe\Stripe::setApiKey($this->getApiKey());

        $readerIDSplit = explode("~~",$readerID);
        $readerID = $readerIDSplit[0];

        $amountDecimal = str_replace('$', '', $card->amount);
        $amountSplit = explode(".",$amountDecimal);
        $amountDollars = $amountSplit[0];
        if(isset($amountSplit[1])){
            $amountCents = $amountSplit[1];
            switch (strlen($amountCents)) {
                case 0:
                    $amountCents = '00';
                case 1:
                    $amountCents = $amountCents .= '0';
                default:
                    $amountCents = substr($amountCents, 0, 2);
            }
        }else{
            $amountCents = '00';
        }
        try {
            //$amount = str_replace('.', '', $amountDecimal);
            $amount = $amountDollars . $amountCents;
            $payment_intent = $stripe->paymentIntents->create([
                'currency' => 'usd',
                'payment_method_types' => ['card_present'],
                'capture_method' => 'manual',
                'amount' => $amount,
                'description' => $card->decription,
                'metadata' => [
                    'userId' => $_SESSION["userID"],
                    'programLocation' => 'ticketPos',
                    'description' => $card->decription,
                    'person_name' => $card->name,
                    'email' => $card->payEmail,
                    'invoice_id' => $card->invoice_id,
                    'invoice_number' => $card->invoice_number,
                    ]
            ]);
        }
        catch (Exception $e){
            return ['Error: '. $e->getMessage(), $card];
        }

        try {
            $stripe->pos->readers->processPaymentIntent(
                $readerID,
                [
                    'payment_intent' => $payment_intent->id,
                    'process_config' => ['enable_customer_cancellation' => true],
                ]
            );

            $this->setPosPurchasesTID($payment_intent->id);
        }

        catch (Exception $e){
            return ['Connection Error: Make sure the Reader is powered on and connected to the WIFI'.$e, $card];
        }
        try {
            $status = $stripe->pos->readers->retrieve($readerID, []);
            if($status['status'] == "online"){
                $status =  $this->keepCheckingForResults($payment_intent->id);
                if($status == 'succeeded'){
                    $ts = new dateTimeService();
                    $card->timeStamp = $ts->createCurrentTimeStamp();
                    $card->ack = $payment_intent->status;
                    $card->transactionID = $payment_intent->id;
                    $_SESSION["TRANSACTIONID"] = $payment_intent->id;
                    $_SESSION['card'] = $this;
                    return [$status, $card];
                }else {
                    return [$status, $card];
                }

            }else{
                $stripe->pos->readers->cancelAction($readerID, []);
                return ['error ' .$status['status'], $card];

            }
        }
        catch (Exception $e){
            $stripe->pos->readers->cancelAction($readerID, []);
            return ['error: '. $e->getMessage(), $card];
        }
    }

    function keepCheckingForResults($paymentIntentId){
        //repeat until results are found or a max of 10
        $terminaObj = '';
        $count = 0;
        while ($count != 10){
            $terminaObj = $this->findResults($paymentIntentId);
            if(is_object($terminaObj)){
                break;
            }
            $count++;
            sleep(1);
        }
        if($terminaObj != ''){
            $this->setPosStatusUserID($_SESSION["userID"]);
            $this->updateUid();
            if($terminaObj->getPosStatusCode() == "succeeded"){
                return 'succeeded';
            }else {
                return 'error: '.$terminaObj->getPosStatusCode().'<br> Message: '.$terminaObj->getPosStatusMessage();
            }
            //echo 'Result: '.$terminaObj->getPosStatusCode().'<br> Message: '.$terminaObj->getPosStatusMessage();
        }
        return "error: No results found";

    }

}