<?php

require_once dirname(dirname(__FILE__),2) . '/LobbyPOS/classes/currency.php';
require_once dirname(dirname(__FILE__),2) . '/LobbyPOS/classes/posDbServices.php';

use lobbypos\posDbServices as PosDbServiceL;

class posItems
{
    private $posItemsID;
    private $posItemsName;
    private $posItemsDescription;
    private $posItemsImage;
    private $posItemsPrice;
    private $posItemsSalesTaxID;
    private $posItemsItemCost;
    private $posItemsItemsOnHand;
    private $posItemsModUser;
    private $posItemsModTimeStamp;
    private $posItemsPosition;
    private $posItemsStatus;
    private $posItemsUseName;
    private $posItemsUseImage;
    private $posItemsUseDescription;

    public function getPosItemsID()
    {
        return $this->posItemsID;
    }

    public function setPosItemsID($posItemsID): void
    {
        $this->posItemsID = $posItemsID;
    }

    public function getPosItemsName()
    {
        return $this->posItemsName;
    }

    public function setPosItemsName($posItemsName): void
    {
        $this->posItemsName = $posItemsName;
    }

    public function getPosItemsDescription()
    {
        return $this->posItemsDescription;
    }

    public function setPosItemsDescription($posItemsDescription): void
    {
        $this->posItemsDescription = $posItemsDescription;
    }

    public function getPosItemsImage()
    {
        return $this->posItemsImage;
    }

    public function setPosItemsImage($posItemsImage): void
    {
        $this->posItemsImage = $posItemsImage;
    }

    public function getPosItemsPrice()
    {
        return $this->posItemsPrice;
    }

    public function setPosItemsPrice($posItemsPrice): void
    {
        $this->posItemsPrice = $posItemsPrice;
    }

    public function getPosItemsSalesTaxID()
    {
        return $this->posItemsSalesTaxID;
    }

    public function setPosItemsSalesTaxID($posItemsSalesTaxID): void
    {
        $this->posItemsSalesTaxID = $posItemsSalesTaxID;
    }

    public function getPosItemsItemCost()
    {
        return $this->posItemsItemCost;
    }

    public function setPosItemsItemCost($posItemsItemCost): void
    {
        $this->posItemsItemCost = $posItemsItemCost;
    }

    public function getPosItemsItemsOnHand()
    {
        return $this->posItemsItemsOnHand;
    }

    public function setPosItemsItemsOnHand($posItemsItemsOnHand): void
    {
        $this->posItemsItemsOnHand = $posItemsItemsOnHand;
    }

    public function getPosItemsModUser()
    {
        return $this->posItemsModUser;
    }

    public function setPosItemsModUser($posItemsModUser): void
    {
        $this->posItemsModUser = $posItemsModUser;
    }

    public function getPosItemsModTimeStamp()
    {
        return $this->posItemsModTimeStamp;
    }

    public function setPosItemsModTimeStamp($posItemsModTimeStamp): void
    {
        $this->posItemsModTimeStamp = $posItemsModTimeStamp;
    }

    public function getPosItemsPosition()
    {
        return $this->posItemsPosition;
    }

    public function setPosItemsPosition($posItemsPosition): void
    {
        $this->posItemsPosition = $posItemsPosition;
    }

    public function getPosItemsStatus()
    {
        return $this->posItemsStatus;
    }

    public function setPosItemsStatus($posItemsStatus): void
    {
        $this->posItemsStatus = $posItemsStatus;
    }

    public function getPosItemsUseName()
    {
        return $this->posItemsUseName;
    }

    public function setPosItemsUseName($posItemsUseName): void
    {
        $this->posItemsUseName = $posItemsUseName;
    }

    public function getPosItemsUseImage()
    {
        return $this->posItemsUseImage;
    }

    public function setPosItemsUseImage($posItemsUseImage): void
    {
        $this->posItemsUseImage = $posItemsUseImage;
    }

    public function getPosItemsUseDescription()
    {
        return $this->posItemsUseDescription;
    }

    public function setPosItemsUseDescription($posItemsUseDescription): void
    {
        $this->posItemsUseDescription = $posItemsUseDescription;
    }

    function itemListForPOS(){

        $db = new PosDbServiceL();
        $conS = $db->dbConnect();
        $noColumns = 0;
        $itemCount = 0;
        if ($conS != null) {
            $resultC = $conS->query("SELECT posConfigItemColumns FROM posConfig");
            if($resultC) {
                while ($c = $resultC->fetch_assoc()) {
                    $noColumns = $c['posConfigItemColumns'];
                }
                $resultC->close();
            }

            $resultS = $conS->query("SELECT * FROM posItems WHERE posItemsStatus = 1 ORDER BY posItemsPosition");
            if($resultS){
                $imagePath = 'images/';
                echo '<table class="posItemsTable">';
                echo '<tr>';
                while ($n = $resultS->fetch_assoc()) {

                    if(($itemCount % $noColumns) == 0){
                        echo '</tr><tr>';
                    }
                    $itemCount++;
                    echo '<td>';
                    echo '<form method="post" action="sections/posPost.php" target="posItemsSelectedFrame">';
                    $itemImage = $n['posItemsImage'];
                    $itemPrice = '$'.number_format(floatval(trim($n['posItemsPrice']/100)),2);
                    if($n['posItemsUseName'] && $itemImage){
                        echo '<button class="posItemButtons" type="submit" name="addItem" >';
                        echo '<img class="posItemImages" alt="'.$itemImage.'" src="'.$imagePath.$itemImage.'">';
                        echo '<br>';
                        echo '<span class="itemFont">'.$n['posItemsName'].'</span>';
                        echo '<br>';
                        echo '<span class="itemFont">'.$itemPrice.'</span>';
                    }elseif ($itemImage){
                        echo '<button class="posItemButtons">';
                        echo '<img class="posItemImages" alt="'.$itemImage.'" src="'.$imagePath.$itemImage.'">';
                        echo '<br>';
                        echo '<span class="itemFont">'.$itemPrice.'</span>';
                    }elseif ($n['posItemsUseName']){
                        echo '<span class="itemFont">'.$n['posItemsName'].'</span>';
                        echo '<br>';
                        echo '<span class="itemFont">'.$itemPrice.'</span>';
                    }
                    if($n['posItemsUseDescription']){
                        //tool tip for hold over or mouse over??
                        //echo $n['posItemsUseDescription'];
                    }
                    echo '</button>';
                    echo '<input type="hidden" name="posItemsID" value="'.$n['posItemsID'].'">';
                    echo '</form>';
                    echo '</td>';
                }
                $resultS->close();
                echo '</tr>';
                echo '</table>';
            }
        }

        $conS = null;
        return '';
    }

    function allItemDetailsByID($itemID){
        $db = new PosDbServiceL();
        $conS = $db->dbConnect();
        if ($conS != null) {

            $resultS = $conS->query("SELECT posItemsName, posItemsPrice, posItemsItemCost, posItemsSalesTaxID FROM posItems WHERE posItemsID  = $itemID");
            if($resultS){

                while ($n = $resultS->fetch_assoc()) {
                    $this->posItemsName = $n['posItemsName'];
                    $this->posItemsPrice = $n['posItemsPrice'];
                    $this->posItemsItemCost = $n['posItemsItemCost'];
                    $this->posItemsSalesTaxID = $n['posItemsSalesTaxID'];
                    return true;

                }
                $resultS->close();
            }
        }
        $conS = null;
        return false;
    }

    function allItemDataByID($itemID){
        $db = new PosDbServiceL();
        $conS = $db->dbConnect();
        if ($conS != null) {

            $resultS = $conS->query("SELECT * FROM posItems WHERE posItemsID  = $itemID");
            if($resultS){

                while ($n = $resultS->fetch_assoc()) {
                    $this->posItemsName = $n['posItemsName'];
                    $this->posItemsPrice = $n['posItemsPrice'];
                    $this->posItemsItemCost = $n['posItemsItemCost'];
                    $this->posItemsSalesTaxID = $n['posItemsSalesTaxID'];
                    $this->posItemsDescription = $n['posItemsDescription'];
                    $this->posItemsImage = $n['posItemsImage'];
                    $this->posItemsItemsOnHand = $n['posItemsItemsOnHand'];
                    $this->posItemsPosition = $n['posItemsPosition'];
                    $this->posItemsStatus = $n['posItemsStatus'];
                    $this->posItemsUseName = $n['posItemsUseName'];
                    $this->posItemsUseImage = $n['posItemsUseImage'];
                    $this->posItemsUseDescription = $n['posItemsUseDescription'];
                    $this->posItemsID = $n['posItemsID'];
                    return true;

                }
                $resultS->close();
            }
        }
        $conS = null;
        return false;
    }


    function itemFormList(){
        $db = new PosDbServiceL();
        $conS = $db->dbConnect();
        if ($conS != null) {

            $currency = new currency();
            $resultS = $conS->query("SELECT posItemsName, posItemsPrice, posItemsID FROM posItems");
            if($resultS){

                while ($n = $resultS->fetch_assoc()) {
                    $this->posItemsName = $n['posItemsName'];
                    $this->posItemsPrice = $n['posItemsPrice'];
                    $this->posItemsID = $n['posItemsID'];
                    echo '<option value="'.$this->posItemsID.'" selected>'.$this->posItemsName.' -> '.$currency->displayCurrency($this->posItemsPrice).'</option>';

                }
                $resultS->close();
            }
        }
        $conS = null;
        return false;
    }

    function itemFormListSelected($itemID){
        $db = new PosDbServiceL();
        $conS = $db->dbConnect();
        if ($conS != null) {

            $currency = new currency();
            $resultS = $conS->query("SELECT posItemsName, posItemsPrice, posItemsID FROM posItems WHERE posItemsID  = $itemID");
            if($resultS){

                while ($n = $resultS->fetch_assoc()) {
                    $this->posItemsName = $n['posItemsName'];
                    $this->posItemsPrice = $n['posItemsPrice'];
                    $this->posItemsID = $n['posItemsID'];

                    if($this->posItemsID == $itemID){
                        $selected = 'selected';
                    }else{
                        $selected = '';
                    }
                    echo '<option value="'.$this->posItemsID.'" '.$selected.'>'.$this->posItemsName.' -> '.$currency->displayCurrency($this->posItemsPrice).'</option>';

                }
                $resultS->close();
            }
        }
        $conS = null;
        return false;
    }

    function addItem(){

        $db = new PosDbServiceL();
        $conC = $db->dbConnect();
        $dt = new dateTimeService();
        $timeStamp = $dt->createCurrentTimeStamp();
        if(isset($_SESSION['userID'])) {
            $userID = $_SESSION['userID'];
        }else {
            $userID = 0;
        }
        if($conC != null){

            //echo '<script>alert(" fee '.$feeName.' desc '.$feeDescription.' Display '.$feeCode.' start '.$feeStartDate.' end '.$feeEndDate.' amount '.$feeAmount.' type '. $feeType.' status '.$feeStatusID.' created '.$feeCreatedBy.'")</script>';
            $createCust = $conC->prepare("INSERT INTO posItems VALUES (null,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
            if($createCust == false) {
                return ' Insert Item Status error ' . mysqli_error($conC);
            }
            $createCust->bind_param("sssiiiiisiiiii",  $this->posItemsName,$this->posItemsDescription, $this->posItemsImage, $this->posItemsPrice, $this->posItemsSalesTaxID, $this->posItemsItemCost, $this->posItemsItemsOnHand, $userID, $timeStamp, $this->posItemsPosition, $this->posItemsStatus, $this->posItemsUseName, $this->posItemsUseImage, $this->posItemsUseDescription);
            if($createCust->execute() == false) {
                return ' Insert Item Status error ' . mysqli_error($conC);
            }
            $this->posItemsID = $createCust->insert_id;

        }
        $conC = null;
        $createCust->close();
        return "Item Added";


    }

    function updateItems($itemsID){

        $db = new PosDbServiceL();
        $conS = $db->dbConnect();
        $dt = new dateTimeService();
        $timeStamp = $dt->createCurrentTimeStamp();
        if(isset($_SESSION['userID'])) {
            $userID = $_SESSION['userID'];
        }else {
            $userID = 0;
        }

        if ($conS != null) {
            $resultC = $conS->prepare("UPDATE posItems SET posItemsName = ?, posItemsDescription = ?, posItemsImage = ?, posItemsPrice = ?, posItemsSalesTaxID = ?, posItemsItemCost = ?, posItemsItemsOnHand = ?, posItemsModUser = ?, posItemsModTimeStamp = ?, posItemsPosition = ?, posItemsStatus = ?, posItemsUseName = ?, posItemsUseImage = ?, posItemsUseDescription = ? WHERE posItemsID = ?");

            if ($resultC === FALSE) {
                return 'Update Pos Item error ' . mysqli_error($conS);
            }

            $resultC->bind_param("sssiiiiisiiiiii",  $this->posItemsName,$this->posItemsDescription, $this->posItemsImage, $this->posItemsPrice, $this->posItemsSalesTaxID, $this->posItemsItemCost, $this->posItemsItemsOnHand, $userID, $timeStamp, $this->posItemsPosition, $this->posItemsStatus, $this->posItemsUseName, $this->posItemsUseImage, $this->posItemsUseDescription, $itemsID);
//            echo '<script>alert("'.$this->showStatus .' for '.$this->showDatesID.'")</script>';
            if ($resultC->execute() === FALSE) {
                return 'Update Pos Item error ' . mysqli_error($conS);
            }
            $resultC->close();

        }

        return "Update Complete";
    }
}