<?php


require_once dirname(dirname(__FILE__),2) . '/LobbyPOS/classes/posCart.php';
require_once dirname(dirname(__FILE__),2) . '/LobbyPOS/classes/posItems.php';
require_once dirname(dirname(__FILE__),2) . '/LobbyPOS/classes/posDbServices.php';

use lobbypos\posDbServices as PosDbServiceL;

class posItemsPurchased
{
    private $posItemsPurchasedID;
    private $posPurchasesID;
    private $posItemsPurchasedName;
    private $posItemsPurchasedItemPrice;
    private $posItemsPurchasedSalesTax;
    private $posItemsPurchasedItemCost;

    public function getPosItemsPurchasedID()
    {
        return $this->posItemsPurchasedID;
    }

    public function setPosItemsPurchasedID($posItemsPurchasedID): void
    {
        $this->posItemsPurchasedID = $posItemsPurchasedID;
    }

    public function getPosPurchasesID()
    {
        return $this->posPurchasesID;
    }

    public function setPosPurchasesID($posPurchasesID): void
    {
        $this->posPurchasesID = $posPurchasesID;
    }

    public function getPosItemsPurchasedName()
    {
        return $this->posItemsPurchasedName;
    }

    public function setPosItemsPurchasedName($posItemsPurchasedName): void
    {
        $this->posItemsPurchasedName = $posItemsPurchasedName;
    }

    public function getPosItemsPurchasedItemPrice()
    {
        return $this->posItemsPurchasedItemPrice;
    }

    public function setPosItemsPurchasedItemPrice($posItemsPurchasedItemPrice): void
    {
        $this->posItemsPurchasedItemPrice = $posItemsPurchasedItemPrice;
    }

    public function getPosItemsPurchasedSalesTax()
    {
        return $this->posItemsPurchasedSalesTax;
    }

    public function setPosItemsPurchasedSalesTax($posItemsPurchasedSalesTax): void
    {
        $this->posItemsPurchasedSalesTax = $posItemsPurchasedSalesTax;
    }

    public function getPosItemsPurchasedItemCost()
    {
        return $this->posItemsPurchasedItemCost;
    }

    public function setPosItemsPurchasedItemCost($posItemsPurchasedItemCost): void
    {
        $this->posItemsPurchasedItemCost = $posItemsPurchasedItemCost;
    }


    function addItem(){

        $db = new PosDbServiceL();
        $conC = $db->dbConnect();

        if($conC != null){

            //echo '<script>alert(" fee '.$feeName.' desc '.$feeDescription.' Display '.$feeCode.' start '.$feeStartDate.' end '.$feeEndDate.' amount '.$feeAmount.' type '. $feeType.' status '.$feeStatusID.' created '.$feeCreatedBy.'")</script>';
            $createCust = $conC->prepare("INSERT INTO posItemsPurchased VALUES (null,?,?,?,?,?)");
            if($createCust == false) {
                error_log(' Insert Item Status error ' . mysqli_error($conC));
            }
            $createCust->bind_param("isiii",  $this->posItemsPurchasedID, $this->posItemsPurchasedName, $this->posItemsPurchasedItemPrice, $this->posItemsPurchasedSalesTax,$this->posItemsPurchasedItemCost);
            if($createCust->execute() == false) {
                error_log(' Insert Item Status error ' . mysqli_error($conC));
            }
            $this->posItemsPurchasedID = $createCust->insert_id;

        }
        $conC = null;
        $createCust->close();
        return true;

    }

    function addItemsFromCart($userID, $posItemsPurchaseID){

        //get items id from cart
        $cart = new posCart();
        $posItemsIDs = $cart->findPurchasedItemsByUser($userID);
        if(sizeof($posItemsIDs) > 0){
            foreach ($posItemsIDs as $itemID){
                //find all item details and store in table
                $posItems = new posItems();
                if($posItems->allItemDetailsByID($itemID)){

                    $this->posItemsPurchasedName = $posItems->getPosItemsName();
                    $this->posItemsPurchasedItemPrice = $posItems->getPosItemsPrice();
                    $this->posItemsPurchasedSalesTax = $posItems->getPosItemsSalesTaxID();
                    $this->posItemsPurchasedItemCost = $posItems->getPosItemsItemCost();
                    $this->posItemsPurchasedID = $posItemsPurchaseID;
                    $this->addItem();

                }
            }
        }else{
            error_log("No Items in Cart posItemsPurchaseClass:109");
        }
        //store the item data into posItemsPurchased Table

    }


}