<?php
if (session_status() == PHP_SESSION_NONE) {
    session_start();
}
if(isset($_GET['US'])){
    $_SESSION["authID"] = $_GET['US'];
    if(isset($_GET['US'])){
        $_SESSION["userID"] = $_GET['US'];
//        echo 'UserId: '.$_GET['US'];
    }

}
if(isset($_GET['newLoad'])){
    if(isset($_SESSION['prevStatusMessage'])){
        unset($_SESSION['prevStatusMessage']);
    }

}
if (!isset($_SESSION["authID"])) {
    header("Location: ../login");
    exit();
}

require_once dirname(dirname(__FILE__)) . '/API/terminal/classes/terminal.php';
require_once dirname(dirname(__FILE__)) . '/LobbyPOS/classes/posItemsPurchased.php';
require_once dirname(dirname(__FILE__)) . '/LobbyPOS/classes/posVariables.php';
require_once dirname(dirname(__FILE__)) . '/classes/dateTimeService.php';
require_once dirname(dirname(__FILE__)) . '/LobbyPOS/classes/posItems.php';
require_once dirname(dirname(__FILE__)) . '/LobbyPOS/classes/posCart.php';
require_once dirname(dirname(__FILE__)) . '/LobbyPOS/classes/pos.php';

if(isset($_POST['terminalID'])){
    $terminaID = explode('~~',$_POST['terminalID']);
    $_SESSION['terminalID'] = $terminaID[0];
    $_SESSION['readerName'] = $terminaID[1];
}

$pos = new pos();
$vars = new posVariables();
$items = new posItems();

if(isset($_POST['cash'])){
    //find current cart total
    //write purchase to table
    $pos = new pos();
    $userID = 0;
    $cashAmount = $_POST['cashAmount'];
    $cashDescription = $_POST['cashDescription'];
    if($cashDescription == ''){
        $cashDescription = "POS Cash Purchase";
    }
    $pos->setPosPurchasesDescription($cashDescription);
    $pos->setPosPurchasesPrice($cashAmount);
    $pos->setPosPurchasesCardType('Cash');
    $pos->setPosPurchasesLast4(0);
    if(isset($_SESSION["userID"])){
        $userID = $_SESSION["userID"];
    }
    $pos->setPosPurchasesUserId($userID);
    $pos->setPosPurchasesPosId('Cash');
    $pos->setPosPurchasesPosName('Cash');
    $pos->setPosPurchasesTID('Cash');
    $pos->setPosPurchaseTip(0);
    $dt = new dateTimeService();
    $timeStamp = $dt->createCurrentTimeStamp();
    $pos->setPosPurchasesTimeStamp($timeStamp);
    $storeTransResults = $pos->storeCompletedTransaction();
    $posItemsPurchased = new posItemsPurchased();
    $posItemsPurchased->addItemsFromCart($userID, $pos->getPosPurchasesId());
    $cart = new posCart();
    $cart->removeItemFromCartByUser($userID);

    $cashMessage = $convertGrandTotal = '$'.number_format(floatval(trim($cashAmount/100)),2).' Paid Cash';
    $_SESSION['prevStatusMessage'] = $cashMessage;
    echo '<script>window.location.replace(window.location.href);</script>';
}

?>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <link rel="stylesheet" type="text/css" href="css/posMain.css" />
    <script src="js/posJs.js"></script>
    <title>Lobby POS</title>
</head>
<body>
<div id="terminal">
    <div class="terminalPage">
        <div class="mainTerminalContainer">
            <div class="terminalContainer">
                <table class="posTopTable">
                    <tr>
                        <td></td>
                        <td>
                            <?php
                            function error($errorMessage){
                                echo '<div id="errorMessage">';
                                echo  $errorMessage;
                                echo '</div>';
                            }
                            ?>
                        </td>
                        <td></td>
                    </tr>

<!--                <iframe class="iframeS" id="statusMessageIframe" name="statusMessageIframe" src="../API/terminal/terminalPost.php"></iframe>-->

                    <tr>
                        <td>
                            <span class="posName"><?php echo $vars->getProgramName()?></span>
                        </td>
                        <td>
                            <div id="pid" style="display: none"></div>
                            <h3 class="terminalDisclaimer"></h3>
                            <iframe src="../API/terminal/terminalPost.php" class="statusMessageIfreame" id="termPostFrame" name="termPostFrame"></iframe>
                        </td>
                        <td>
                            <form method="post" action="#" style="display: inline-block">
                                <?php
                                echo $pos->listPossPOS();
                                ?>
                            </form>
                            <button onclick="toggleScroll()" class="freezeButton">Freeze</button>
                        </td>
                    </tr>
                </table>
                    <div id="itemsDiv">
                        <table class="posItemsTable">
                            <tr>
                                <td colspan="3">
                                    <div id="pid" style="display: none"></div>
                                    <?php
                                    $items->itemListForPOS();
                                    ?>
                                </td>
                                <td></td>
                                <td></td>
                            </tr>
                            <tr>
                                <td colspan="3">
                                    <iframe src="sections/posPost.php" id="posItemsSelectedFrame" name="posItemsSelectedFrame" scrolling="yes"></iframe>
                                </td>
                                <td></td>
                                <td></td>
                            </tr>
                            <tr>
                                <td colspan="3">
                                    <textarea class="terminalTextArea" id="descriptionText" name="description" onkeypress="getDescriptionData()"></textarea>
                                </td>
                                <td></td>
                                <td></td>
                            </tr>
                        </table>
                    </div>
                <table class="posTable">
                    <td>
                        <input class="terminalInput totalBox" type="text" id="totalBox" name="totalBox" maxlength="10" required disabled>
                    </td>
                    <td>
                        <form method="post" action="../API/terminal/terminalPost.php" target="termPostFrame">
                        <div class="terminalButtonBox">
                            <input type="hidden" name="programLocation" id="programLocation" value="lobbyTerminal">
                            <input type="hidden" name="amount" id="amount" value="">
                            <input type="hidden" name="posInput" id="posInput" value="posInput">
                            <input type="hidden" name="description" id="description" value="">
                            <input type="hidden" name="readerId" id="readerIdCancel" value="">
                            <?php
                            if(isset($_SESSION['terminalID'])){
                                echo '<input type="hidden" name="readerId" id="readerIdProcess" value="'.$_SESSION['terminalID'].'">';
                                echo '<input type="hidden" name="readerName" id="readerNameProcess" value="'.$_SESSION['readerName'].'">';
                            }
                            ?>
                            <input class="terminalButton" type="submit" id="sendToTerminal" value="Send To Terminal">

                        </div>
                        </form>
                        <form method="post" action="../API/terminal/terminalPost.php" id="cancelTerminal" target="termPostFrame" style="display: none">
                            <div class="terminalButtonBox">
                                <?php
                                if(isset($_SESSION['terminalID'])){
                                    echo '<input type="hidden" name="readerId" id="readerIdCancel" value="'.$_SESSION['terminalID'].'">';
                                    echo '<input type="hidden" name="readerName" id="readerNameProcess" value="'.$_SESSION['readerName'].'">';
                                }
                                ?>
                                <input class="terminalButton" type="submit" id="cancel" name="cancel" value="Cancel">
                            </div>
                        </form>
                    </td>
                    <td>
                        <form method="post" action="#">
                            <div class="terminalButtonBox">
                                <input type="hidden" name="cashDescription" id="cashDescription" value="">
                                <input type="hidden" name="cashAmount" id="cashAmount" value="">
                                <input type="hidden" name="piReceipt" id="piReceipt" value="">
                                <input class="terminalButton" type="submit" name="cash" value="Cash">
                            </div>
                        </form>
                    </td>
                </tr>
                </table>
            </div>
        </div>
    </div>
</div>

</body>
<script>
    var readerSelection = document.getElementById("readerId");

    readerSelection.addEventListener("click", function() {
        var options = readerSelection.querySelectorAll("option");
        var count = options.length;
        if(typeof(count) === "undefined" || count < 2)
        {
            valueForCancel();
        }
    });

    readerSelection.addEventListener("change", function() {
        if(activities.value == "addNew")
        {
            valueForCancel();
        }
    });
</script>
</html>
