<?php

class currency
{

    function displayCurrency($amount){
        return '$'.number_format(floatval(trim($amount/100)),2);
    }

    function convertPriceForDB($amount){

        $amountDecimal = str_replace('$', '', $amount);
        $amountSplit = explode(".",$amountDecimal);
        $amountDollars = $amountSplit[0];
        if(isset($amountSplit[1])){
            $amountCents = $amountSplit[1];
            switch (strlen($amountCents)) {
                case 0:
                    $amountCents = '00';
                case 1:
                    $amountCents = $amountCents .= '0';
                default:
                    $amountCents = substr($amountCents, 0, 2);
            }
        }else{
            $amountCents = '00';
        }
        return $amountDollars . $amountCents;
    }
}