<?php

require_once dirname(dirname(__FILE__),2) . '/LobbyPOS/classes/pos.php';



class posEmail
{

    function sendEmail($pos){
        $recFilePath = dirname(dirname(__FILE__)) . '/pdf/';
        $fileName = $pos->getPosPurchasesFileName();

        $to = '';
        if(isset($_SESSION['resend'])){
            $subject = 'TOR Reprint - Theatre of the Republic Pos Receipt';
        }else {
            $subject = 'Theatre of the Republic Pos Receipt';
        }
        $boundary = md5(time());
        $headers = "From: \"Theatre of the Republic-Pos-Receipt\" <boxoffice@thetor.biz>\r\n";
        $headers .= "Reply-To: boxoffice@thetor.biz\r\n";
        $headers .= "MIME-Version: 1.0\r\n";
        $headers .= "Content-Type: multipart/mixed; boundary=\"$boundary\"\r\n";

        $bcc = 'michaeldsmb@gmail.com, rcfoultz@gmail.com, boxoffice@thetor.biz';
        //$bcc = 'michaeldsmb@gmail.com, rcfoultz@gmail.com';
        $headers .= "Bcc: $bcc\r\n";
        $message = "--$boundary\r\n";
        $message .= "Content-Type: text/html; charset=UTF-8\r\n";
        $message .= "Content-Transfer-Encoding: 7bit\r\n";
        $message .= "\r\n";
        $message .= "<html><body>";
        //$message .= "<h1>Hello, World!</h1>";
        $message .= "<p>Thank you for supporting Theatre of the Republic.  <br><br>Attached is your receipt.<br>Theatre of the Republic<br>331 Main Street<br>Conway  SC  29562<br>843.488.0821</p>";
        $message .= "</body></html>\r\n";

        $completeFileToAttach = $recFilePath.$fileName;
        $message .= $this->addAttachment($completeFileToAttach,$boundary,"Reciept file");
        $message .= "--$boundary--";

        if (!mail($to, $subject, $message, $headers)) {
            error_log("Failed to send email to $to");
        }

    }

    function addAttachment($filePath, $boundary, $fileDescription) {
        if (file_exists($filePath)) {
            $fileName = basename($filePath);
            $fileContent = chunk_split(base64_encode(file_get_contents($filePath)));
            $fileType = $this->getMimeType($filePath);

            $attachment = "--$boundary\r\n";
            $attachment .= "Content-Type: $fileType; name=\"$fileName\"\r\n";
            $attachment .= "Content-Transfer-Encoding: base64\r\n";
            $attachment .= "Content-Disposition: attachment; filename=\"$fileName\"\r\n";
            $attachment .= "\r\n";
            $attachment .= $fileContent . "\r\n";

            return $attachment;
        } else {
            error_log($fileDescription . " File not found: $filePath");
            return '';
        }
    }

    function getMimeType($filePath) {
        $mimeTypes = [
            'txt' => 'text/plain',
            'html' => 'text/html',
            'htm' => 'text/html',
            'jpg' => 'image/jpeg',
            'jpeg' => 'image/jpeg',
            'png' => 'image/png',
            'gif' => 'image/gif',
            'pdf' => 'application/pdf',
            // Add more extensions and their MIME types as needed
        ];

        $ext = strtolower(pathinfo($filePath, PATHINFO_EXTENSION));
        return isset($mimeTypes[$ext]) ? $mimeTypes[$ext] : 'application/octet-stream';
    }

}