<?php

require_once dirname(dirname(__FILE__),2) . '/receipt/pdf/fpdf.php';
require_once dirname(dirname(__FILE__),2) . '/classes/dateTimeService.php';
require_once dirname(dirname(__FILE__),2) . '/LobbyPOS/classes/pos.php';

class posPdf
{


    function createPDFFIle($pos){
       $pdf = new FPDF();
       $pdf->AddPage();
       $pdf->SetFont('Arial','B',16);
       $pdf->Image(dirname(dirname(__FILE__),2) . '/images/locations/tor.png',70,10, 70,26);
       $pdf->Text(74,46,"Theatre Of the Republic");
       $pdf->Text(87, 53, "Receipt");

       $pdf->SetFont('Arial','B',12);
       $dt = new dateTimeService();
       $convertTime = $dt->convertDateForFileName($pos->getPosPurchasesTimeStamp());
       $invoiceNumber = $dt->convertTimeStampToNumber($pos->getPosPurchasesTimeStamp());
       $pdf->Text(74,61, "Receipt Number: ".$invoiceNumber.$pos->getPosPurchasesId());
       $pdf->Text(10, 71, $pos->getPosPurchasesDescription());
       $pdf->Text(10,79, $pos->getPosPurchasesCardType().' **'.$pos->getPosPurchasesLast4());
//       $pdf->Text(10,87, $rec->getRecCity()." ". $rec->getRecState()." ". $rec->getRecZip());
//       $pdf->Text(10,95, $rec->getRecPhone());
//       $pdf->Text(10,103, $rec->getRecEmail());
//
//        $pdf->Text(10,111, $rec->getRecQuantity1()."  ". $rec->getRecDescription1()."  ".$rec->getRecAmount1());
//        $pdf->Text(10,119, $rec->getRecQuantity2()."  ". $rec->getRecDescription2()."  ".$rec->getRecAmount2());
//        $pdf->Text(10,127, $rec->getRecQuantity3()."  ". $rec->getRecDescription3()."  ".$rec->getRecAmount3());


       $rowCount = 140;


        $pdf->Text(10,$rowCount, "Credit Card: $" .number_format(floatval(($pos->getPosPurchasesPrice()/100)),2));
        $rowCount = $rowCount + 9;
        $pdf->Text(10,$rowCount, "Transaction Code: " .$pos->getPosPurchasesTID().'US'.$pos->getPosPurchasesUserId().'T'.$pos->getPosPurchasesPosId());

       $pdf->Text(10,266, $convertTime);
       $pdf->Text(22, 282, "Thank you for supporting the Arts in Horry County.  We look forward to seeing you.");
       $pdf->SetFont('Arial','B',9);
       $pdf->Text(50, 290, "Theatre Of the Republic   331 Main St  Conway  SC  29526   843.488.0821");
        //$this->pdf->AddPage();\


        $filePath = dirname(dirname(__FILE__)) . '/pdf/';
        $fileName = $pos->getPosPurchasesDescription().'_'.$pos->getPosPurchasesTID().'_'.$invoiceNumber.'_TOR_Pos_Receipt.pdf';
        $pdf->Output('F',$filePath.$fileName);
        //$pdf->Output();

        return $fileName;

    }

}